package com.ruoyi.framework.config;

import com.ruoyi.common.utils.Threads;
import com.ruoyi.framework.config.properties.ThreadPoolProperties;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.concurrent.BasicThreadFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.scheduling.concurrent.ThreadPoolTaskScheduler;

import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledThreadPoolExecutor;
import java.util.concurrent.ThreadPoolExecutor;

/**
 * 线程池配置
 *
 * @author Lion Li
 **/
@Configuration
@Slf4j
@EnableScheduling
public class ThreadPoolConfig {

  /**
   * 核心线程数 = cpu 核心数 + 1
   */
  private final int core = Runtime.getRuntime().availableProcessors() + 1;

  @Autowired
  private ThreadPoolProperties threadPoolProperties;

  @Bean(name = "threadPoolTaskExecutor")
  @ConditionalOnProperty(prefix = "thread-pool" , name = "enabled" , havingValue = "true")
  public ThreadPoolTaskExecutor threadPoolTaskExecutor() {
    ThreadPoolTaskExecutor executor = new ThreadPoolTaskExecutor();
    executor.setThreadNamePrefix("tp-");
    executor.setCorePoolSize(core);
    executor.setMaxPoolSize(core * 2);
    executor.setQueueCapacity(threadPoolProperties.getQueueCapacity());
    executor.setKeepAliveSeconds(threadPoolProperties.getKeepAliveSeconds());
    executor.setRejectedExecutionHandler(new ThreadPoolExecutor.CallerRunsPolicy());
    return executor;
  }

  /**
   * 执行周期性或定时任务
   */
  @Bean(name = "scheduledExecutorService")
  protected ScheduledExecutorService scheduledExecutorService() {

    ScheduledThreadPoolExecutor s = null;

    return new ScheduledThreadPoolExecutor(core,
      new BasicThreadFactory.Builder().namingPattern("schedule-pool-%d").daemon(true).build(),
      new ThreadPoolExecutor.CallerRunsPolicy()) {
      @Override
      protected void afterExecute(Runnable r, Throwable t) {
        super.afterExecute(r, t);
        Threads.printException(r, t);
      }
    };
  }

  @Bean
  @ConditionalOnMissingBean(ThreadPoolTaskScheduler.class)
  public ThreadPoolTaskScheduler threadPoolTaskScheduler() {
    ThreadPoolTaskScheduler t = new ThreadPoolTaskScheduler();

    t.setPoolSize(core * 2 + 1);                        // 线程池大小
    t.setThreadNamePrefix("t-");   // 线程名称
    t.setAwaitTerminationSeconds(60);         // 等待时长
    t.setWaitForTasksToCompleteOnShutdown(true);  // 调度器shutdown被调用时等待当前被调度的任务完成
    t.initialize();
    log.info("创建了自定义线程池{}*，size:{}" , t.getThreadNamePrefix(), t.getPoolSize());
    return t;
  }

}

